/*
 * Copyright (C) 2023 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.thema.graphab.metric;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.AbstractTableModel;
import org.geotools.feature.SchemaException;
import org.thema.graphab.MainFrame;
import org.thema.graphab.Project;
import org.thema.graphab.metric.global.GlobalMetricResult;

/**
 *
 * @author gvuidel
 */
public class MetricDialog extends javax.swing.JDialog {

    private Project project;
    private List<MetricResult> metrics;
    
    /**
     * Creates new form MetricDialog
     * @param parent
     * @param project
     */
    public MetricDialog(java.awt.Frame parent, Project project) {
        super(parent, false);
        initComponents();

        updateMetrics(project);
        
        globalTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent lse) {
                updateInfo();
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        closeButton = new javax.swing.JButton();
        showButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        globalPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        globalTable = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        infoTextArea = new javax.swing.JTextArea();

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle"); // NOI18N
        setTitle(bundle.getString("MetricDialog.title")); // NOI18N

        closeButton.setText(bundle.getString("MetricDialog.closeButton.text")); // NOI18N
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        showButton.setText(bundle.getString("MetricDialog.showButton.text")); // NOI18N
        showButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showButtonActionPerformed(evt);
            }
        });

        removeButton.setText(bundle.getString("MetricDialog.removeButton.text")); // NOI18N
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        globalTable.setAutoCreateRowSorter(true);
        globalTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Metric", "Type", "Graph", "Result"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(globalTable);

        infoTextArea.setEditable(false);
        infoTextArea.setColumns(20);
        infoTextArea.setRows(5);
        jScrollPane2.setViewportView(infoTextArea);

        javax.swing.GroupLayout globalPanelLayout = new javax.swing.GroupLayout(globalPanel);
        globalPanel.setLayout(globalPanelLayout);
        globalPanelLayout.setHorizontalGroup(
            globalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 472, Short.MAX_VALUE)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 472, Short.MAX_VALUE)
        );
        globalPanelLayout.setVerticalGroup(
            globalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(globalPanelLayout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 200, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 158, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(globalPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(removeButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(showButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(closeButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addComponent(showButton)
                        .addGap(18, 18, 18)
                        .addComponent(removeButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(closeButton))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(globalPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        setVisible(false);
    }//GEN-LAST:event_closeButtonActionPerformed

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        int row = globalTable.getSelectedRow();
        if(row < 0) {
            return;
        } 
        MetricResult m = metrics.get(globalTable.getRowSorter().convertRowIndexToModel(row));
        int res = JOptionPane.showConfirmDialog(this, 
                java.text.MessageFormat.format(java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle").getString("DO YOU WANT TO REMOVE THE METRIC {0} ?"), m.getFullName()), 
                java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle").getString("REMOVE METRIC"), JOptionPane.YES_NO_OPTION);
        if(res != JOptionPane.YES_OPTION) {
            return;
        }
        try {
            project.removeMetric(m.getFullName());
            updateMetrics(project);
        } catch (IOException | SchemaException ex) {
            throw new RuntimeException(ex);
        }
    }//GEN-LAST:event_removeButtonActionPerformed

    private void showButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showButtonActionPerformed
        int row = globalTable.getSelectedRow();
        if(row < 0) {
            return;
        } 
        MetricResult m = metrics.get(globalTable.getRowSorter().convertRowIndexToModel(row));
        if(m.getMethod() == Project.Method.GLOBAL) {
            return;
        }
        int indAttr = 0;
        if(((AbstractAttributeMetricResult)m).getAttrNames().size() > 1) {
            indAttr = JOptionPane.showOptionDialog(this, 
                    java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle").getString("SELECT ATTRIBUTE METRIC"), 
                    java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle").getString("SHOW METRIC"), 
                    JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE, null, ((AbstractAttributeMetricResult)m).getAttrNames().toArray(), null);
            if(indAttr == JOptionPane.CLOSED_OPTION) {
                return;
            }
        }
        MainFrame.viewMetricResult(m, indAttr);
    }//GEN-LAST:event_showButtonActionPerformed

    public final void updateMetrics(Project project) {
        this.project = project;
        metrics = new ArrayList<>(project.getMetrics().values());
        globalTable.setModel(new MetricTable());
    }

    public void updateInfo() {
        int row = globalTable.getSelectedRow();
        if(row < 0) {
            infoTextArea.setText(""); //NOI18N
        } else {
            MetricResult m = metrics.get(globalTable.getRowSorter().convertRowIndexToModel(row));
            infoTextArea.setText(MetricResult.getInfo(m));
        }
    }
    
    public class MetricTable extends AbstractTableModel {
        
        private String [] colNames = new String [] {
            java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle").getString("METRIC"), 
            java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle").getString("TYPE"), 
            java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle").getString("GRAPH"), 
            java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle").getString("RESULT")};

        @Override
        public int getRowCount() {
            return metrics.size();
        }

        @Override
        public int getColumnCount() {
            return colNames.length;
        }

        @Override
        public String getColumnName(int column) {
            return colNames[column];
        }
        
        @Override
        public Object getValueAt(int row, int col) {
            MetricResult m = metrics.get(row);
            switch(col) {
                case 0:
                    return m.getName();
                case 1: 
                    return m.getMethod().toString();
                case 2: 
                    return m.getGraph().getName();
                case 3: 
                    return m.getMethod() == Project.Method.GLOBAL ? Arrays.toString(((GlobalMetricResult)m).getResult()) : null;
                default:
                    throw new IllegalArgumentException("unknown column " + col); //NOI18N
            }
        }
    
    }      
    


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JPanel globalPanel;
    private javax.swing.JTable globalTable;
    private javax.swing.JTextArea infoTextArea;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton removeButton;
    private javax.swing.JButton showButton;
    // End of variables declaration//GEN-END:variables
}

